package com.link.core.converter.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.management.ManagementFactory;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class SystemEx {
   private static final String VBS_GET_PROCESSOR_IDS = "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_Processor\")\nFor Each item in col\n  Wscript.Echo item.ProcessorId\nNext\n";
   private static final String VBS_GET_BASE_BOARD_SN = "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_BaseBoard\")\nFor Each item in col\n  Wscript.Echo item.SerialNumber\n  Exit For\nNext\n";
   private static final String VBS_GET_PHYSICAL_MEDIA_SNS = "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_PhysicalMedia\")\nFor Each item in col\n  Wscript.Echo item.SerialNumber\nNext\n";
   private static final String VBS_GET_PHYSICAL_MEMORY_SNS = "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_PhysicalMemory\")\nFor Each item in col\n  Wscript.Echo item.SerialNumber\nNext\n";

   public static String getOsName() {
      return System.getProperty("os.name");
   }

   public static boolean isWindows() {
      return getOsName().toLowerCase().indexOf("windows") >= 0;
   }

   public static boolean isLinux() {
      return getOsName().toLowerCase().indexOf("linus") >= 0;
   }

   public static List<String> getProcessorIds() throws IOException {
      if (!isWindows()) {
         return new ArrayList();
      } else {
         BufferedReader reader = callVbs("getProcessorIds", "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_Processor\")\nFor Each item in col\n  Wscript.Echo item.ProcessorId\nNext\n");

         ArrayList var3;
         try {
            List<String> ids = new ArrayList();

            for(String id = reader.readLine(); id != null; id = reader.readLine()) {
               if (!StringUtil.isNullOrBlank(id)) {
                  ids.add(id.trim());
               }
            }

            var3 = ids;
         } finally {
            reader.close();
         }

         return var3;
      }
   }

   public static String getBaseBoardSn() throws IOException {
      if (!isWindows()) {
         return null;
      } else {
         BufferedReader reader = callVbs("getBaseBoardIds", "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_BaseBoard\")\nFor Each item in col\n  Wscript.Echo item.SerialNumber\n  Exit For\nNext\n");

         String var2;
         try {
            String sn = reader.readLine();
            var2 = sn == null ? null : sn.trim();
         } finally {
            reader.close();
         }

         return var2;
      }
   }

   public static List<String> getPhysicalMediaSns() throws IOException {
      if (!isWindows()) {
         return new ArrayList();
      } else {
         BufferedReader reader = callVbs("getPhysicalMediaSns", "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_PhysicalMedia\")\nFor Each item in col\n  Wscript.Echo item.SerialNumber\nNext\n");

         ArrayList var3;
         try {
            List<String> sns = new ArrayList();

            for(String sn = reader.readLine(); sn != null; sn = reader.readLine()) {
               if (!StringUtil.isNullOrBlank(sn)) {
                  sns.add(sn.trim());
               }
            }

            var3 = sns;
         } finally {
            reader.close();
         }

         return var3;
      }
   }

   public static List<String> getPhysicalMemorySns() throws IOException {
      if (!isWindows()) {
         return new ArrayList();
      } else {
         BufferedReader reader = callVbs("getPhysicalMemorySns", "Set wmiService = GetObject(\"winmgmts://./root/cimv2\")\nSet col = wmiService.ExecQuery(\"Select * from Win32_PhysicalMemory\")\nFor Each item in col\n  Wscript.Echo item.SerialNumber\nNext\n");

         ArrayList var3;
         try {
            List<String> sns = new ArrayList();

            for(String sn = reader.readLine(); sn != null; sn = reader.readLine()) {
               if (!StringUtil.isNullOrBlank(sn)) {
                  sns.add(sn.trim());
               }
            }

            var3 = sns;
         } finally {
            reader.close();
         }

         return var3;
      }
   }

   public static boolean isEnableAssertions() {
      String[] OPTIONS = new String[]{"-ea", "-enableassertions"};
      String SEPARATOR = ":";
      List<String> args = ManagementFactory.getRuntimeMXBean().getInputArguments();
      Iterator var3 = args.iterator();

      while(var3.hasNext()) {
         String arg = (String)var3.next();
         String arg_ = arg.toLowerCase();
         String[] var6 = OPTIONS;
         int var7 = OPTIONS.length;

         for(int var8 = 0; var8 < var7; ++var8) {
            String option = var6[var8];
            if (option.equals(arg_)) {
               return true;
            }

            if (arg_.startsWith(option + ":")) {
               return true;
            }
         }
      }

      return false;
   }

   private static BufferedReader callVbs(String filePrefix, String vbs) throws IOException {
      assert filePrefix != null;

      assert vbs != null;

      File file = File.createTempFile(filePrefix, ".vbs");
      file.deleteOnExit();
      FileWriter fw = new FileWriter(file);

      try {
         fw.write(vbs);
      } finally {
         fw.close();
      }

      Process process = Runtime.getRuntime().exec("cscript //nologo " + file.getPath());
      return new BufferedReader(new InputStreamReader(process.getInputStream()));
   }
}
